// Name: Keldin Maldonado
// Date: 2023-04-11
// Title: Lab6 Step 2
// Description: producer--consumer program for lab6 step 2.

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <unistd.h>

#define BUFFER 10
#define LETTERS 26

void *producer(void *arg);
void *consumer(void *arg);

sem_t full;
sem_t empty;
sem_t mutex;

int buffer[LETTERS];

int main() {
  pthread_t produce_thread, consume_thread;

  sem_init(&full, 0, 0);
  sem_init(&empty, 0, BUFFER);
  sem_init(&mutex, 0, 1);

  pthread_create(&produce_thread, NULL, producer, NULL);
  pthread_create(&consume_thread, NULL, consumer, NULL);

  pthread_join(produce_thread, NULL);
  pthread_join(consume_thread, NULL);

  sem_destroy(&mutex);
  sem_destroy(&empty);
  sem_destroy(&full);

  return 0;
}

void *producer(void *arg) {
  char letter = 'A';
  int in = 0;

  for(int i = 0; i < LETTERS; i++) {
    sem_wait(&empty);
    sem_wait(&mutex);

    buffer[in] = letter;
    printf("Produced letter %c\n", letter);
    in = (in + 1) % LETTERS;

    sem_post(&mutex);
    sem_post(&full);

    letter++;

    sleep(1);
  }
}

void *consumer(void *arg) {
  char letter;
  int out = 0;

  for(int i = 0; i < LETTERS; i++) {
    sem_wait(&full);
    sem_wait(&mutex);

    letter = buffer[out];
    printf("Consumed letter %c\n", letter);
    out = (out + 1) % LETTERS;

    sem_post(&mutex);
    sem_post(&empty);

    sleep(1);
  }
}
